package co.yixiang.yshop.module.distributor.service.distributorlevel;

import java.util.*;
import javax.validation.*;

import co.yixiang.yshop.module.distributor.controller.admin.distributorlevel.vo.*;
import co.yixiang.yshop.module.distributor.dal.dataobject.distributorlevel.DistributorLevelDO;
import co.yixiang.yshop.framework.common.pojo.PageResult;

/**
 * 分销商等级 Service 接口
 *
 * @author admin
 */
public interface DistributorLevelService {

    /**
     * 创建分销商等级
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createLevel(@Valid DistributorLevelCreateReqVO createReqVO);

    /**
     * 更新分销商等级
     *
     * @param updateReqVO 更新信息
     */
    void updateLevel(@Valid DistributorLevelUpdateReqVO updateReqVO);

    /**
     * 删除分销商等级
     *
     * @param id 编号
     */
    void deleteLevel(Long id);

    /**
     * 获得分销商等级
     *
     * @param id 编号
     * @return 分销商等级
     */
    DistributorLevelDO getLevel(Long id);

    /**
     * 获得分销商等级列表
     *
     * @param ids 编号
     * @return 分销商等级列表
     */
    List<DistributorLevelDO> getLevelList(Collection<Long> ids);

    /**
     * 获得分销商等级分页
     *
     * @param pageReqVO 分页查询
     * @return 分销商等级分页
     */
    PageResult<DistributorLevelDO> getLevelPage(DistributorLevelPageReqVO pageReqVO);

    /**
     * 获得分销商等级列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 分销商等级列表
     */
    List<DistributorLevelDO> getLevelList(DistributorLevelExportReqVO exportReqVO);

    // 获取默认等级
    DistributorLevelDO getDefaultLevel();

}
